/*
 * ----------------------------------------------------------------------------
 * "THE BEER-WARE LICENSE" (Revision 42):
 * <joerg@FreeBSD.ORG> wrote this file.  As long as you retain this notice you
 * can do whatever you want with this stuff. If we meet some day, and you think
 * this stuff is worth it, you can buy me a beer in return.        Joerg Wunsch
 * ----------------------------------------------------------------------------
 *
 * Simple AVR demonstration.  Controls a LED that can be directly
 * connected from OC1/OC1A to GND.  The brightness of the LED is
 * controlled with the PWM.  After each period of the PWM, the PWM
 * value is either incremented or decremented, that's all.
 *
 * $Id: demo.c,v 1.6.2.3 2006/01/05 21:33:08 joerg_wunsch Exp $
 */
 
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "funcs.h"


/* ========== main ========== */
int
main (void)
{

	// 0 = LED on, 1 = LED off
	
	uint8_t toggle = 0;
	DDRA = 0x55;  // LEDs as output, buttons as input
 

	PORTA = 0x00; // Set Buttons as pull-up because buttons are connected to GND and switch on LEDs
	
	myfunc(); // Should switch off LEDs
    
    while (1) // Start endless loop
	{

		if((PINA & 0x02) == 0x02) // Check if Button 1 is pushed
		{
			PORTA |= 0x01; // LED1 off
		}
		else
		{
			PORTA &= ~0x01; // LED1 on
		}
		
		/* Heartbeat 
			To show the CPU activity by a LED
		*/
		// Heart beat LED3
		int i;
		
		for(i=0; i<250; i++) { _delay_ms(1); }
		for(i=0; i<250; i++) { _delay_ms(1); }
		for(i=0; i<250; i++) { _delay_ms(1); }
		
		if(toggle == 1){
			PORTA |= 0x10; // LED3 off
			toggle = 0;
		}else{
			PORTA &= ~0x10; // LED3 on
			toggle = 1;
		}

	}
    return (0);
}
